# Examples

This repository contains [examples](examples/README.md) of models which use the `Makina` library.

All test in the examples can be run with:

```
$ mix test
```

## Project structure

This repository contains an umbrella project. Each example is stored in its own subproject under the
`examples` directory.

Every subproject stores the system-under test under `lib` directory and the model that tests it under
`test/lib` directory.

Notice that with this configuration the models are only loaded in the test environment. If you want
to interact with the model from an elixir interpreter you need to start the interpreter in the test
environment:

```
$ MIX_ENV=test iex -S mix
```


## How to add new examples

First you need to move to the directory that stores the subprojects:

```
$ cd examples
```

Then, you need to create a new subproject:

```
$ mix new [name]
```

This creates a new subproject in `examples/[name]`.

In order to be able to store the models inside `test/lib` the elixir compiler needs to look for that
path in the test environment. This can be achieved by adding the following code to the `mix.exs`:

```elixir
def project do
  [
    ...
    elixirc_paths: compiler_paths(Mix.env())
  ]

defp compiler_paths(:test), do: ["test/lib"] ++ compiler_paths(:prod)
defp compiler_paths(_), do: ["lib"]
```


Finally, you need to import the libraries in `common`, which are `Makina` and `PropCheck`. To do so
you can add the following code to the `mix.exs`:

```elixir
defp deps do
  [
    {:common, in_umbrella: true}
  ]
end
```

## Generated code

To examine the code produced by Makina, you can use the `Makro` module. To do so, first, you need to
add the `makro` library to `mix.exs` in `common`. This can be accomplished by modifying the `deps`
function as follows:

```elixir
defp deps do
    [
      {:makro, git: "git@gitlab.com:babel-upm/makro.git"} # DEBUG
    ]
end
```

To use this library, you need to configure it using `config/config.exs`. For instance, if you want
to view the code generated by all the models, you can add the following code to the top-level
configuration file:

```elixir
config :makro, debug_directory: ".makina"

debug_code =
  quote do
    use Makro.Debug
  end

config :makina, checker: PropCheck# , debug: debug_code
```

Then, you can force the compilation to produce a new directory `.makina`, containing the results of
compiling each model. You can achieve this by running the following command:

```shell
$ mix compile --force
```
